import { ofType } from 'redux-observable';
import { concat, EMPTY, of, timer } from 'rxjs';
import { debounce, switchMap } from 'rxjs/operators';

import { GET_XRAY_LINE_ITEM_CREATIVES_OPTIONS } from '@/graphql/services/xRayLineItems/constants';

import { PAYLOAD_NAME } from '@/graphql/services/xRayLineItems/types/payload/creative';

import { hubSelector } from '../selectors';
import { getXRayCreativeOptionsAction, setAction } from '../slices';
import { gqlRequest } from '@/modules/@common/request';

const query = `
  query ${GET_XRAY_LINE_ITEM_CREATIVES_OPTIONS}($payload: ${PAYLOAD_NAME}) {
    ${GET_XRAY_LINE_ITEM_CREATIVES_OPTIONS}(payload: $payload) {
      records {
        id
        name
     }   
    }
  }
`;

const getResponse = ({ data }) => data[GET_XRAY_LINE_ITEM_CREATIVES_OPTIONS].records;

export default (action$, state$) =>
  action$.pipe(
    ofType(getXRayCreativeOptionsAction.type),
    debounce((action) => {
      const search = action.payload;
      return timer(search?.length > 1 ? 1000 : 0);
    }),
    switchMap((action) => {
      const publisherId = hubSelector(state$.value)?.id;

      if (!publisherId) {
        return EMPTY;
      }

      const stream$ = gqlRequest({
        query,
        variables: {
          payload: {
            searchText: action.payload ?? '',
            publisherId,
            pageSize: 30,
          },
        },
      }).pipe(
        switchMap((response) => {
          if (!response.errors.length) {
            return of(
              setAction({
                xrayCreativeOptions: getResponse(response),
              }),
            );
          }

          return EMPTY;
        }),
      );

      return concat(stream$);
    }),
  );
